
 
 <script setup name="Menu">
 import  user from "@/api/system/user";
 import  archivesApi from "@/api/archivesApi/index";
import { ElMessage } from 'element-plus'
 import  waterMeterApi from "@/api/waterMeterApi/index";
import { waterMeterCloseAccountApi }  from '@/api/workOrderManage/waterMeterCloseAccountApi/index';
import  billRecord from "@/api/financial/billRecord/index";
 import setPostParams from "../../../utils/searchParams.js";
 const { proxy } = getCurrentInstance();
 
/**
 * 搜索相关
 */
 /** 搜索按钮操作 */
 function handleQuery() {
   getList({keywords:queryParams.value.name,page:1})
 }
 
 /** 重置按钮操作 */
 function resetQuery() {
   proxy.resetForm("queryRef");
   handleQuery();
 }

 /**
  *  Table表格权限数据列表相关
  */

const pageParam = ref({
    total:0,
    limit:0,
    page:0,
})
const tableData = ref([]);
let  tableHeader = ref({
        id: '序号',
        workNumber: '工单编号',
        userName: "用户姓名",
        classifyName: "用户类型",
        userCode: "户号",
        userPhone: "用户电话",
        businessAddress: "营业点",
        userAddress: "用户地址",
        meterSn: "水表编号",
        installAddress: "安装地址",
        isArrearageView: "是否欠费",
        executeTypeView: "执行状态",
        createTimeView: "创建日期",
   })
 /** 获取列表 */
 async function getList(val) {
      loading.value = true;
     let postParam = setPostParams(val)
      await waterMeterCloseAccountApi().search(postParam).then((res) =>{
        tableData.value = res.data.list
        pageParam.value.total = res.data.total
        pageParam.value.limit = res.data.limit
        pageParam.value.page = res.data.page
    })
    loading.value = false;
 }
 
 /** 新增按钮操作 */
 async function handleAdd() {
   reset();
   title.value = "新增销户";
    open.value = true;
 }
 
 /**
  *  新增/修改弹窗Form表单相关
  */
const open = ref(false);
const loading = ref(false);
const title = ref("");

const data = reactive({
form:{},
queryParams: {
    name: undefined,
},
rules: {
    userName: [{ required: true, message: "请选择用户", trigger: "blur" }],
    constructionUser: [{ required: true, message: "请选择施工人员", trigger: "blur" }],
    constructionTime: [{ required: true, message: "请选择上门时间", trigger: "blur" }],
    operatorUser: [{ required: true, message: "请选择经办人", trigger: "blur" }],
    meterSn: [{ required: true, message: "请选择注销水表", trigger: "blur" }],
},
});
const { queryParams, form, rules } = toRefs(data);

    //获取账号列表选择
    const constructionUserList = ref()
    const operatorUserList = ref()
    const userList = ref()
 const getAllList = async() =>{
    // 获取用户档案列表
    let res5 = await archivesApi().search({limit: 10000, status: 1,page:1})
    if (res5.code == 200) {
    userList.value = res5.data.list
    }
    let res6 = await user().search({limit: 10000, status: 1,page:1})
    if (res6.code == 200) {
        constructionUserList.value = res6.data.list
        operatorUserList.value = res6.data.list
    }
 }
 const waterMeterList = ref()
 //选择用户获取对应水表列表
const changeUser = async (val) => {
    form.value.meterSn=""
    //选中用户显示用户信息
    let user = userList.value.find((item) => item.id == val)
    Object.keys(user).forEach((key) =>{
        if(form.value.hasOwnProperty(key)){
            form.value[key] = user[key]
        }
    })
    //请求该用户名下水表
    let res3 = await waterMeterApi().getByUser(val)
    if (res3.code == 200) {
        waterMeterList.value = res3.data
    }
}
//选中水表获取欠费信息
const changeWaterMeter = async (val) => {
let res1 = await billRecord().getMeterArrearsAmount(val)
    if (res1.code == 200) {
        form.value.isArrearage = res1.data
    }
}
//根据经办人id添加经办人Name
const changeOperatorUser = async (val) => {
    operatorUserList.value.forEach((item) =>{
        if(item.id == val){
            form.value.operatorUserName = item.nickName
        }
    })
    console.log('45646',form.value);
}
//根据施工人员id添加施工人员Name
const changeConstructionUser = (val)=>{
    constructionUserList.value.forEach((item) =>{
        if(item.id == val){
            form.value.constructionUserName = item.nickName
        }
    })
}
 /** 提交按钮 */
 function submitForm() {
   proxy.$refs["formRef"].validate(valid => {
     if (valid) {
       if (form.value.id != undefined) {
         waterMeterCloseAccountApi().modify(form.value).then(res => {
           proxy.$modal.msgSuccess("修改成功");
           open.value = false;
           getList();
         }).catch(() =>{
            open.value = false;
            proxy.$modal.msgError("修改失败");
         });
       } else {
        waterMeterCloseAccountApi().create(form.value).then(res => {
           proxy.$modal.msgSuccess("新增成功");
           open.value = false;
           getList();
         }).catch(() =>{
            open.value = false;
            proxy.$modal.msgError("新增失败");
         });
       }
     }
   });
 }

 /** 取消按钮 */
 function cancel() {
   open.value = false;
   reset();
 }

 /** 表单重置 */
 function reset() {
   form.value = {
        classifyTxt: '',
        classifyId: 0,
        userId: "",
        userName: "",
        idCard: "",
        userCode: "",
        modeCode: "",
        userAddress: "",
        userPhone: "",
        meterSn: "",
        address: "",
        operatorUser: "",
        operatorUserName: "",
        constructionUser: "",
        constructionUserName: "",
        constructionTime:"",
        isArrearage: 0,
        remark: "",
   };
   proxy.resetForm("formRef");
 }
  /**
  * 详情、执行相关
  */
const formDetail = ref()
const formDetailVisible = ref()
const isExecute = ref(false)
const ToDetail = async(row,val) =>{
    let res = await waterMeterCloseAccountApi().get(row.id)
    if(res.code == 200) {
        formDetail.value = res.data
    }
    formDetailVisible.value = true
    if(val === 2){
        isExecute.value = true
    }else{
        isExecute.value = false
    } 
}
// 提交确认报修
const acceptAccountForm = async() =>{
    let res = await waterMeterCloseAccountApi().execute({id:formDetail.value.id,executeType:2})
    if(res.code == 200){
        ElMessage({message:'已接受销户申请!',type:'success'})
    }
    formDetailVisible.value = false
    getList()
}
// 提交完成报修
const completeAccountForm = async() =>{
    let res = await waterMeterCloseAccountApi().execute({id:formDetail.value.id,executeType:3})
    if(res.code == 200){
        ElMessage({message:'完成销户!',type:'success'})
    }
    formDetailVisible.value = false
    getList()
}
// 撤销报修
const revokeAccountForm = async() =>{
    let res = await waterMeterCloseAccountApi().execute({id:formDetail.value.id,executeType:4})
    if(res.code == 200){
        ElMessage({message:'撤销成功!',type:'success'})
    }
    formDetailVisible.value = false
    getList()
}
 getList();
 getAllList()
 </script>
 <template>
    <div class="app-container">
       <el-form :model="queryParams" ref="queryRef" :inline="true">
          <el-form-item  prop="name">
             <el-input
                v-model="queryParams.name"
                placeholder="请输入水表编号"
                clearable
                style="width: 200px"
                @keyup.enter="handleQuery"
             />
          </el-form-item>
          <el-form-item>
             <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
             <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
       </el-form>
 
       <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
             <el-button
                type="primary"
                plain
                icon="Plus"
                @click="handleAdd"
             >新增</el-button>
          </el-col>
       </el-row>
       <!--表格及分页-->
       <el-table v-loading="loading" :data="tableData">
          <el-table-column
            v-for="(item, key, index) of tableHeader"
            :prop="key.toString()"
            :label="item"
            :key="index"
            align="center"
          >
        </el-table-column>
          <el-table-column label="操作" width="180" align="center" class-name="small-padding fixed-width">
             <template #default="scope">
                <el-button @click="ToDetail(scope.row,1)"  link type="primary" icon="Document" title="详细信息">详情</el-button>
                <el-button v-if="(scope.row.executeType == 1) || (scope.row.executeType == 2)" @click="ToDetail(scope.row,2)"  link type="primary" icon="EditPen" title="详细信息">执行</el-button>
             </template>
          </el-table-column>
        </el-table>
        <pagination
          :total="pageParam.total"
          v-model:page="pageParam.page"
          v-model:limit="pageParam.limit"
          :page-sizes="[10,20,30]"
          @pagination="getList"
        />
       <!-- 添加或修改对话框 -->
       <el-dialog :title="title" v-model="open" append-to-body center>
            <el-form class="form-box" ref="formRef" :model="form" :rules="rules" label-width='auto'>
                <el-form-item label="用户名称"  prop="userId">
                    <el-select v-model="form.userId" filterable placeholder="请输入或选择开户人" @change="changeUser">
                        <el-option
                                v-for="(item,index) in userList"
                                :key="item.id"
                                :label="item.userName"
                                :title="item.userName"
                                :value="item.id"
                        />
                    </el-select>
                </el-form-item>

                <el-form-item label="用户类型:" prop="classifyTxt">{{
                    form.classifyTxt
                    }}
                </el-form-item>
                <el-form-item label="联系电话:"  prop="userPhone">
                    {{ form.userPhone }}
                </el-form-item>
                <el-form-item label="身份证号码:"  prop="idCard">
                    {{ form.idCard }}
                </el-form-item>
                <el-form-item label="用户地址:"  prop="userAddress">
                    {{ form.userAddress}}
                </el-form-item>
                <el-form-item label="户号:"  prop="userCode">
                    {{ form.userCode }}
                </el-form-item>
                <el-form-item label="注销水表:"  prop="meterSn">
                    <el-select v-model="form.meterSn"  filterable
                                placeholder="请选择要注销的水表编号" @change="changeWaterMeter">
                        <el-option
                                v-for="item in waterMeterList"
                                :key="item.id"
                                :label="item.sn"
                                :title="item.sn"
                                :value="item.sn"
                                size="large"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="欠费金额:"  prop="isArrearage">
                    {{ form.isArrearage }}
                </el-form-item>
                <el-form-item label="施工人员"  prop="constructionUser">
                    <el-select v-model="form.constructionUser"  filterable
                                placeholder="请选择施工人员"  @change="changeConstructionUser">
                        <el-option
                                v-for="item in constructionUserList"
                                :key="item.id"
                                :label="item.nickName"
                                :title="item.nickName"
                                :value="item.id"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="上门时间"  prop="constructionTime">
                        <el-date-picker
                            v-model="form.constructionTime"
                            type="date"
                            placeholder="请选择安装日期和时间"
                            format="YYYY-MM-DD"
                            value-format="YYYY-MM-DD"
                            style="width: 100%"
                        />
                </el-form-item>
                <el-form-item label="经办人"  prop="operatorUser">
                    <el-select v-model="form.operatorUser" class="m-2" filterable
                            placeholder="请选择经办人"  @change="changeOperatorUser">
                        <el-option
                                v-for="item in operatorUserList"
                                :key="item.id"
                                :label="item.nickName"
                                :title="item.nickName"
                                :value="item.id"
                        />
                    </el-select>
                </el-form-item>

                <el-form-item label="备注"  prop="remark">
                    <el-input v-model="form.remark"></el-input>
                </el-form-item>
            </el-form>
          <template #footer>
             <div class="dialog-footer">
                <el-button type="primary" @click="submitForm">确 定</el-button>
                <el-button @click="cancel">取 消</el-button>
             </div>
          </template>
       </el-dialog>
       
       <el-dialog v-model="formDetailVisible" title="水表维修详情" style="width: 60vw;" center align-center >
        <div class="detail">
                    <div class="item">
                        <div class="title">工单编号:</div>
                        <div>{{ formDetail.workNumber }}</div>
                    </div>
                    <div class="item">
                        <div class="title">用户姓名:</div>
                        <div>{{ formDetail.userName }}</div>
                    </div>
                    <div class="item">
                        <div class="title">用户编号:</div>
                        <div>{{ formDetail.userCode }}</div>
                    </div>
                    <div class="item">
                        <div class="title">用户类型:</div>
                        <div>{{ formDetail.classifyName }}</div>
                    </div>
                    <div class="item">
                        <div class="title">用户电话:</div>
                        <div>{{ formDetail.userPhone }}</div>
                    </div>
                    <div class="item">
                        <div class="title">用户地址:</div>
                        <div>{{ formDetail.userAddress }}</div>
                    </div>
                    <div class="item">
                        <div class="title">销户水表编号:</div>
                        <div>{{ formDetail.meterSn }}</div>
                    </div>
                    <div class="item">
                        <div class="title">水表安装地址:</div>
                        <div>{{ formDetail.installAddress }}</div>
                    </div>
                    <div class="item">
                        <div class="title">是否欠费:</div>
                        <div>{{ formDetail.isArrearage == 0 ? '否' : '是' }}</div>
                    </div>
                    <div class="item">
                        <div class="title">执行状态:</div>
                        <div>{{ formDetail.executeTypeView }}</div>
                    </div>
                    <div class="item">
                        <div>施工人员:</div>
                        <div>{{ formDetail.constructionUserName }}</div>
                    </div>
                    <div class="item">
                        <div>上门时间:</div>
                        <div>{{ formDetail.constructionTime }}</div>
                    </div>
                    <div class="item">
                        <div>经办人姓名:</div>
                        <div>{{ formDetail.operatorUserName }}</div>
                    </div>
                    <div class="item">
                        <div>创建时间:</div>
                        <div>{{ formDetail.createTimeView }}</div>
                    </div>
                    <div class="item">
                        <div>更新时间:</div>
                        <div>{{ formDetail.updateTime }}</div>
                    </div>
                    <div class="item">
                        <div>创建人:</div>
                        <div>{{ formDetail.createUserName }}</div>
                    </div>
                    <div class="item">
                        <div>更新人:</div>
                        <div>{{ formDetail.updateUserName }}</div>
                    </div>
                </div>
            <template #footer>
                <el-button v-if="!isExecute" @click="formDetailVisible = false" style="width:10%">关闭</el-button>
                <div class="Execution-btn" v-if="isExecute">
                    <div>
                        <el-button v-if="formDetail.executeType==1" type="primary" size="large" @click="acceptAccountForm">接受销户</el-button>
                    </div>
                    <div>
                        <el-button v-if="formDetail.executeType==2" type="primary" size="large" @click="completeAccountForm">完成销户</el-button>
                    </div>
                    <div>
                        <el-button v-if="formDetail.executeType==1" type="primary" size="large" @click="revokeAccountForm">撤销工单</el-button>
                    </div>
                </div>
            </template>
        </el-dialog>
    </div>
 </template>
 <style>
.Execution-btn{
        display: flex;
        justify-content: center;
        div{
            margin: 0 10px 10px 10px;
        }
    }
    .detail{
    display:flex;
    justify-content:flex-start;
    width:100%;
    flex-wrap:wrap;
    padding-left: 50px;
    .item{
    margin-bottom: 15px;
    width:45%;
    font-size: 18px;
    display: flex;
    .title{
        color: #696969;
        margin-right: 10px;
    }
}
}    
</style>
 